#* 
#* ------------------------------------------------------------------
#* BWHelp.tcl -- Simple HyperHelp popup dialog
#* ------------------------------------------------------------------
#* HelpIndexBuild.tcl - Index builder program
#* Created by Robert Heller on Thu Feb  9 19:59:32 2006
#* ------------------------------------------------------------------
#* Modification History: $Log: HelpIndexBuild.tcl,v $
#* Modification History: Revision 1.2  2006/02/10 01:01:26  heller
#* Modification History: Final lockdown
#* Modification History:
#* ------------------------------------------------------------------
#* Contents:
#* ------------------------------------------------------------------
#*  
#* Copyright (c) 2006, Robert Heller
#* All rights reserved.
#* 
#* Redistribution and use in source and binary forms, with or without
#* modification, are permitted provided that the following conditions are
#* met:
#* 
#*     * Redistributions of source code must retain the above copyright
#*       notice, this list of conditions and the following disclaimer.
#*     * Redistributions in binary form must reproduce the above copyright
#*       notice, this list of conditions and the following disclaimer in the
#*       documentation and/or other materials provided with the distribution.
#*     * Neither the name of the Deepwoods Software nor the names of its
#*       contributors may be used to endorse or promote products derived from
#*       this software without specific prior written permission.
#* 
#* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
#* IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
#* TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
#* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#* 
#* 

global HLinePattern
set HLinePattern {^([0-9]+)[ 	](.*)$}

global argc argv
if {$argc < 2} {
  error "Missing args!"
}

if {[catch [list open [lindex $argv 0] w] indexfp]} {
  error "open: [lindex $argv 0]: $indexfp"
}

for {set i 1} {$i < $argc} {incr i} {
  set file [lindex $argv $i]
  if {[catch [list open $file r] hfp]} {
    puts stderr "Warning: open $file: $hfp"
    puts stderr "Skiping: $file"
    continue
  }
  set prefixList {}
  set pos [tell $hfp]
  while {[gets $hfp line] >= 0} {
    global HLinePattern
    if {[regexp "$HLinePattern" "$line" whole level heading] > 0} {
      if {$level < [llength $prefixList]} {
	if {$level == 0} {
	  set prefixList {}
        } else {
	  set prefixList [lrange $prefixList 0 [expr $level -1]]
	}
      }
      lappend prefixList "$heading"
      puts $indexfp [list [join $prefixList {>}] [list $file $pos]]
    }
    set pos [tell $hfp]
  }
  close $hfp
}



