#* 
#* ------------------------------------------------------------------
#* BWHelp.tcl -- Simple HyperHelp popup dialog
#* ------------------------------------------------------------------
#* IndexHH.tcl - index.hh builder
#* Created by Robert Heller on Thu Feb  9 20:00:40 2006
#* ------------------------------------------------------------------
#* Modification History: $Log: IndexHH.tcl,v $
#* Modification History: Revision 1.2  2006/02/10 01:01:26  heller
#* Modification History: Final lockdown
#* Modification History:
#* ------------------------------------------------------------------
#* Contents:
#* ------------------------------------------------------------------
#*  
#* Copyright (c) 2006, Robert Heller
#* All rights reserved.
#* 
#* Redistribution and use in source and binary forms, with or without
#* modification, are permitted provided that the following conditions are
#* met:
#* 
#*     * Redistributions of source code must retain the above copyright
#*       notice, this list of conditions and the following disclaimer.
#*     * Redistributions in binary form must reproduce the above copyright
#*       notice, this list of conditions and the following disclaimer in the
#*       documentation and/or other materials provided with the distribution.
#*     * Neither the name of the Deepwoods Software nor the names of its
#*       contributors may be used to endorse or promote products derived from
#*       this software without specific prior written permission.
#* 
#* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
#* IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
#* TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
#* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#* 
#* 

global argc argv
if {$argc < 2} {
  error "Missing args!"
}

set HelpIndex [lindex $argv 0]
set IndexHH   [lindex $argv 1]

if {[catch [list open $HelpIndex r] indxFp]} {
  error "open: $HelpIndex: $indxFp"
}

set indexList {}

while {[gets $indxFp line] >= 0} {
  set key [lindex $line 0]
  set klist [split $key {>}]
  set indexItem [lindex $klist end]
  lappend indexList "$indexItem"
}

close $indxFp

if {[catch [list open $IndexHH w] ihhFp]} {
  error "open: $IndexHH: $ihhFp"
}

puts $ihhFp "0 Index"

foreach k [lsort $indexList] {
  puts $ihhFp "<$k>"
}

close $ihhFp


if {[catch [list open $HelpIndex a] indxFp]} {
  error "open: $HelpIndex: $indxFp"
}

puts $indxFp [list Index [list $IndexHH 0]]
close $indxFp
